]> git.sesse.net Git - backup.sh/blobdiff - backup.sh
Support changing compressors (e.g. to get zstd or xz).
[backup.sh] / backup.sh
index 2a6d66693033a6505e228122917343448e1ee9b8..e64312f529f68b3021a2751c2c75ef186092f85a 100755 (executable)
--- a/backup.sh
+++ b/backup.sh
 # The script is halfway Norwegian and halfway English. Newer modifications are
 # in English, we should probably stick to that.
 
-# The computer to backup.
-computer=$1
-
-# Configuration
-LOCKFILE=/home/backup/backuprun.lockfile.$computer
-confdir=/home/backup/conf/              # Configuration files
-storagedir=/backup                      # Where we keep backups
-maxnumfull=3                            # Number of full backups
-daysbetweenfull=30                      # Days between full backups
-daysbetweenfullforfixed=32              # Days between full backups for machines with fixed
-                                        # full-backup date (in case the fixed day gets missed)
-DAY_OF_MONTH=`date "+%d" | sed s/^0//`  # from 1 to 31
-DATE=`date "+%Y%m%d%H%M"`               #format: touch
-DATEs=`date "+%Y-%m-%d %H:%M"`          #format: tar
-
-# Exclude-pattern
-exclude=$confdir/exclude
-[ ! -f $exclude ] && printf "tmp\ncore\n" > $exclude
+computer=$1                                      # The computer to backup.
+SCRIPTPATH="$( cd "$(dirname "$0")" ; pwd -P )"  # Absolute directory the script lives in
+confdir=$SCRIPTPATH/conf                         # Directory for configuration files
+conffile=$confdir/backup.config
+LOCKFILE=$SCRIPTPATH/backuprun.lockfile.$computer
+DAY_OF_MONTH=`date "+%d" | sed s/^0//`           # from 1 to 31
+DATE=`date "+%Y%m%d%H%M"`                        # format: touch
+DATEs=`date "+%Y-%m-%d %H:%M"`                   # format: tar
+TOP_PID=$$
 
 if [ -z "$computer" ]; then
        echo "Usage: $0 COMPUTER"
        exit 1
 fi
 
+[ ! -f $exclude ] && printf "tmp\ncore\n" > $exclude
+
 # Die more or less gracefully (at least notify user)
 die() {
-       echo `date`": Something nasty happened."
+       warnmsg "Aborting."
        rm $LOCKFILE
        exit 1
 }
 diemsg() {
-       echo `date`": $computer: $@"
+       warnmsg "$@"
        die
 }
+warnmsg() {
+       echo `date`": $computer: $@"
+       echo `date`": $computer: $@" >&2
+}
+infomsg() {
+       echo `date`": $computer: $@" >&2
+}
+findconf() {  # getconf is already taken
+       key=$1
+       computer=$2
+       filesystem=$( echo $3 | tr / . )
+
+       if [ "$computer" ] && [ "$filesystem" ] && git config -f $conffile $computer$filesystem.$key > /dev/null; then
+               git config -f $conffile $computer$filesystem.$key
+       elif [ "$computer" ] && git config -f $conffile $computer.$key > /dev/null; then
+               git config -f $conffile $computer.$key
+       elif git config -f $conffile defaults.$key > /dev/null; then
+               git config -f $conffile defaults.$key
+       else
+               warnmsg "No configuration found for $key in $conffile, aborting."
+               kill -TERM $TOP_PID
+       fi
+}
 
 # Trap C-c and kill
 trap die SIGINT SIGTERM
 
-# Don't start if we're already running
+# Don't start if we're already running. Don't use diemsg, as that removes the lock file!
 if [ -e $LOCKFILE ]; then
-       echo `date`": $LOCKFILE exists for pid `cat $LOCKFILE`, exiting."
-       echo `date`": $LOCKFILE exists for pid `cat $LOCKFILE`, exiting." >&2
+       warnmsg "$LOCKFILE exists for pid `cat $LOCKFILE`."
        exit 1
 fi;
 touch $LOCKFILE
 echo $$ > $LOCKFILE
 
-echo `date`": Backup run starting" >&2
+infomsg "Backup run starting"
 
 umask 027
 
-
 backup()
 {
-       echo -n `date` >&2
-       printf " $computer: $computer:$filesystem $backuplevel backup\n" >&2
+       infomsg "$computer:$filesystem $backuplevel backup"
 
-       SNARFILE="${storagedir}/${computer}/${sfilesystem}/.incremental.snar"
-       incrementalsnar="/root/.backup/${sfilesystem}.snar"
-       if [ "$backuplevel" = "daglig" ]
-       then
+       localsnar="${storagedir}/${computer}/${sfilesystem}/.incremental.snar"
+       remotesnar="$remotehome/.backup/${sfilesystem}.snar"
+       if [ "$backuplevel" = "daily" ]; then
                # If incremental backup, we need to copy the incremental status to $computer.
                # If it does not exist, whine a bit and then run date-based instead.
-               if [ -s "$SNARFILE" ]; then
-                       if ! scp $SNARFILE root@$computer:$incrementalsnar; then
+               if [ -s "$localsnar" ]; then
+                       if ! scp $localsnar $username@$computer:$remotesnar >&2; then
                                diemsg "Could not copy .incremental.snar to $computer"
                        fi
-                       lastcmd="--listed-incremental=$incrementalsnar --no-check-device"
+                       lastcmd="--listed-incremental=$remotesnar --no-check-device"
                else
-                       echo `date`" $computer: Missing incremental.snar for $filesystem, doing date-based backup instead until next full backup" >&2
-                       incrementalsnar=""
+                       infomsg "Missing incremental.snar for $filesystem, doing date-based backup instead until next full backup"
+                       remotesnar=""
                        lastd=`cat ../.date`
                        lastcmd="--newer='$lastd'"
                fi
        else
-               lastcmd="--listed-incremental=$incrementalsnar"
+               # Note: Since we rm-ed .backup previously, and we don't scp over
+               # anything in this branch, this file will not exist, and we
+               # will be doing a full backup (but we want the output of it).
+               lastcmd="--listed-incremental=$remotesnar"
+       fi
+
+       # The file is usually stored to disk with a simple cat > $TARFILE,
+       # but in some cases, like backing up to a remote and untrusted
+       # file system, it could be useful to replace it with e.g.
+       # a GPG command line.
+       storageprogram=$( findconf storageprogram $computer $sfilesystem )
+
+       # Find compressor and decompressor for this filesystem.
+       fscompressor=$( findconf compressor $computer $filesystem )
+       if [ -z "$fscompressor" ]; then
+               fscompressor=$compressor
        fi
+       decompressor=$( findconf decompressor $computer $filesystem )
 
        # We try to run tar on the remote computer
        #    c create archive
@@ -107,34 +135,35 @@ backup()
        #    Pipe the stuff over ssh to ourselves, run pee to cat the contents to a
        #    file and build a file list, respectivly.  
        TARFILE=$DATE.tmp
-       TARCMD="ssh root@$computer \"nice -n 19 ionice -c3 tar --one-file-system --use-compress-program $compressor -cf - -C $filesystem . $lastcmd \
-               --exclude-from=/root/.backup/exclude\" | pee \"cat > $TARFILE\" \"tar tzvf -\""
-       echo `date`" $computer: Running $TARCMD" >&2
+       TARCMD="ssh -n $username@$computer \"$nice tar --one-file-system --use-compress-program $fscompressor -cf - -C $filesystem . $lastcmd \
+               --exclude-from=$remotehome/.backup/exclude\" | pee \"$storageprogram > $TARFILE\" \"$decompressor | tar tvf -\""
+       infomsg "Running $TARCMD"
        eval $TARCMD > $DATE.idx
 
        if [ $? -eq 0 ] && [ -s $TARFILE ]; then
                # File is >0 in size and neither cat or tar tzvf failed; we assume it worked.
-
-               if ! scp root@$computer:$incrementalsnar $SNARFILE.tmp; then
-                       diemsg "Could not copy .incremental.snar from $computer"
+               if [ "$remotesnar" ]; then
+                       if ! scp $username@$computer:$remotesnar $localsnar.tmp >&2; then
+                               diemsg "Could not copy .incremental.snar from $computer"
+                       fi
                fi
 
                # Move tar file in place
                mv $TARFILE $DATE.tgz
-               mv $SNARFILE.tmp $SNARFILE
+               if [ "$remotesnar" ]; then
+                       mv $localsnar.tmp $localsnar
+               fi
 
                # Update timestamp
                echo $DATEs > ../.date && touch -t $DATE ../.date
 
-               # Make a sorted file list as well
-               sort -k6 < $DATE.idx > $DATE.sdx
-
                # Fix permissions
                chmod 600 *tgz                      #only for us
-               chmod 644 *sdx *idx 2>/dev/null     #everyone can read
+               chmod 644 *idx 2>/dev/null          #everyone can read
 
                # Let the remote computer know that we ran a successful backup (for nagios)
-               ssh root@$computer touch $filesystem/.lastbackup
+               ssh -n $username@$computer touch $filesystem/.lastbackup
        else
                # Something wrong happened.
                rm $TARFILE
@@ -142,64 +171,129 @@ backup()
        fi
 }
 
+# Non-privileged backups currently have a few limitations compared to regular ones:
+#
+#  - No .idx files.
+#  - No .snar-style incremental backups, only date-based.
+#  - No touching of .lastbackup for Nagios.
+#  - Failed tar operations may go undetected, since we only see the error code
+#    the last process in the pipe chain, which is gpg.
+#  - No storageprogram support (see above), because the file is typically already
+#    encrypted.
+nonprivbackup()
+{
+       infomsg "$computer:$filesystem $backuplevel non-privileged backup"
+
+       if [ "$backuplevel" = "daily" ]; then
+               lastd=`cat ../.date`
+               lastcmd="'$lastd'"
+       else
+               lastcmd=""
+       fi
+
+       TARFILE=$DATE.tmp
+       TARCMD="ssh -n $username@$computer \"sudo /usr/local/sbin/output-encrypted-backup $filesystem $lastcmd\""
+       infomsg "Running $TARCMD"
+       eval $TARCMD > $TARFILE
+
+       if [ $? -eq 0 ] && [ -s $TARFILE ]; then
+               # File is >0 in size and the remote side did not report any fatal errors; we assume it worked.
+
+               # Move tar file in place
+               mv $TARFILE $DATE.tgz.gpg
+
+               # Update timestamp
+               echo $DATEs > ../.date && touch -t $DATE ../.date
+
+               # Fix permissions
+               chmod 600 *tgz.gpg                  #only for us
+       else
+               # Something wrong happened.
+               rm $TARFILE
+               diemsg "tar failed or $TARFILE empty. $backuplevel backup of $computer:$filesystem failed and deleted"
+       fi
+}
+
+# Get basic configuration.
+storagedir=$( findconf storagedir $computer )
+username=$( findconf username $computer )
+exclude=$( findconf excludefile $computer )
+
 # Check that the target filesystem is mounted (actually check that it's not
 # the root filesystem)
 if [ ! -d "$storagedir/$computer" ]; then
-       diemsg "Target filesystem ($storagedir/$computer) does not exist. Aborting"
+       diemsg "Target filesystem ($storagedir/$computer) does not exist."
 fi
 rootfilesystem=`df -P /`
 targetfilesystem=`df -P "$storagedir/$computer"`
 if [ "$rootfilesystem" == "$targetfilesystem" ]; then
-       diemsg "Target filesystem ($storagedir/$computer) was mounted on /. Aborting"
+       diemsg "Target filesystem ($storagedir/$computer) was mounted on /."
 fi
-
-echo `date`" $computer: Backing up $computer" >&2
+infomsg "Backing up $computer"
 
 # Try to SSH to the computer without entering a password.
-if ! `ssh -n -o NumberOfPasswordPrompts=0 root@$computer /bin/true`; then
+if ! ssh -n -o NumberOfPasswordPrompts=0 $username@$computer /bin/true; then
        diemsg "Could not use passwordless SSH."
 fi
 
-# Check if pigz is available
-if ssh -n root@$computer "pigz -V 2>/dev/null"; then
-       compressor=pigz
+# Find the home directory of the backup user
+remotehome=`ssh -n $username@$computer "echo ~"`
+if [ -z "$remotehome" ]; then
+       diemsg "Could not expand ~ for user $username"
+fi
+
+# Check if pigz is available. Note that this may be overridden per-filesystem later.
+compressor=$( findconf compressor $computer )
+if [ -z "$compressor" ]; then
+       if ssh -n $username@$computer "pigz -V 2>/dev/null"; then
+               compressor=pigz
+       else
+               infomsg "pigz missing; falling back to gzip."
+               compressor=gzip
+       fi
+fi
+
+# Check if nice and ionice are available
+if ssh -n $username@$computer "nice -n 19 ionice -c3 /bin/true 2>/dev/null"; then
+       nice="nice -n 19 ionice -c3"
 else
-       echo `date`" $computer: pigz missing; falling back to gzip."
-       compressor=gzip
+       infomsg "nice and/or ionice missing; will run at normal priority."
+       nice=""
 fi
 
 # Check dump bit in fstab
-filesystems=`ssh -n root@$computer "cat /etc/fstab" \
+filesystems=`ssh -n $username@$computer "cat /etc/fstab" \
        | grep -v nfs \
        | grep -v "^#" \
        | grep -v "^$" \
        | awk '{ if ( $(NF-1) != "0" ) print $2}' `
 
 # Clean up our dir at this client
-if ! ssh root@$computer "rm -r /root/.backup ; mkdir -m 700 /root/.backup"; then
-       diemsg "Could not create backup staging area at $computer:/root/.backup"
+if ! ssh -n $username@$computer "rm -r $remotehome/.backup ; mkdir -m 700 $remotehome/.backup"; then
+       diemsg "Could not create backup staging area at $computer:$remotehome/.backup"
 fi
 
 # Try to copy $exclude to $computer
-if ! scp $exclude root@$computer:/root/.backup/exclude > /dev/null; then
+if ! scp $exclude $username@$computer:$remotehome/.backup/exclude >&2; then
        diemsg "Could not copy exclude.txt to $computer"
 fi
 
 # Try to copy preeexec and postexec if they exist
 if [ -f $confdir/preexec.$computer ]; then
-       if ! scp $confdir/preexec.$computer  root@$computer:/root/.backup/preexec >&2; then
-               diemsg "Could not copy preexec.$computer to $computer:/root/.backup/preexec"
+       if ! scp $confdir/preexec.$computer $username@$computer:$remotehome/.backup/preexec >&2; then
+               diemsg "Could not copy preexec.$computer to $computer:$remotehome/.backup/preexec"
        fi
 fi
 if [ -f $confdir/postexec.$computer ]; then
-       if ! scp $confdir/postexec.$computer root@$computer:/root/.backup/postexec >&2; then
-               diemsg "Could not copy postexec.$computer to $computer:/root/.backup/postexec"
+       if ! scp $confdir/postexec.$computer $username@$computer:$remotehome/.backup/postexec >&2; then
+               diemsg "Could not copy postexec.$computer to $computer:$remotehome/.backup/postexec"
        fi
 fi
 
 # Try to run preexec if it exists
-if ! ssh root@$computer "[ ! -f /root/.backup/preexec ] || /bin/bash -x /root/.backup/preexec" >&2; then
-       diemsg "Could not run $computer:/root/.backup/preexec"
+if ! ssh -n $username@$computer "[ ! -f $remotehome/.backup/preexec ] || /bin/bash -x $remotehome/.backup/preexec" >&2; then
+       diemsg "Could not run $computer:$remotehome/.backup/preexec"
 fi
 
 for filesystem in $filesystems; do
@@ -208,63 +302,54 @@ for filesystem in $filesystems; do
 
        # Prepare storage area
        mkdir -m 755 -p $storagedir/$computer/$sfilesystem/full 2>/dev/null
-       mkdir -m 755 -p $storagedir/$computer/$sfilesystem/daglig 2>/dev/null
+       mkdir -m 755 -p $storagedir/$computer/$sfilesystem/daily 2>/dev/null
 
        # Default backuplevel
-       backuplevel=daglig
+       backuplevel=daily
 
-       if [ ! -f $storagedir/$computer/$sfilesystem/.date ]
-       then
+       if [ ! -s $storagedir/$computer/$sfilesystem/.date ]; then
                # Take the first full backup of this filesystem on this computer
                backuplevel=full
-               echo $DATEs > $storagedir/$computer/$sfilesystem/.date
        fi
 
        # Check if we want a full backup
-       if [ -f $confdir/fastfullbackupdag.$computer.$sfilesystem ]; then
-               fullbackup_min_for_this_machine=$daysbetweenfullforfixed
-               if [ "$DAY_OF_MONTH" = "`cat $confdir/fastfullbackupdag.$computer.$sfilesystem`" ]; then
-                       backuplevel=full
-               fi
-       elif [ -f $confdir/fastfullbackupdag.$computer ]; then
-               fullbackup_min_for_this_machine=$daysbetweenfullforfixed
-               if [ "$DAY_OF_MONTH" = "`cat $confdir/fastfullbackupdag.$computer`" ]; then
+       fixedfullbackupday=$( findconf fixedfullbackupday $computer $filesystem )
+       if [ "$fixedfullbackupday" ]; then
+               fullbackup_min_for_this_machine=$( findconf daysbetweenfullforfixed $computer $filesystem )
+               if [ "$DAY_OF_MONTH" = "$fixedfullbackupday" ]; then
                        backuplevel=full
                fi
        else
-               fullbackup_min_for_this_machine=$daysbetweenfull 
+               fullbackup_min_for_this_machine=$( findconf daysbetweenfull $computer $filesystem )
        fi
 
-       if [ -z "`find $storagedir/$computer/$sfilesystem/full/ -name \*tgz -mtime -$fullbackup_min_for_this_machine`" ]; then
+       if [ -z "`find $storagedir/$computer/$sfilesystem/full/ -name \*tgz\* -mtime -$fullbackup_min_for_this_machine`" ]; then
                backuplevel=full
        fi
 
        # We want to be here
-       cd $storagedir/$computer/$sfilesystem/$backuplevelmsg || die "$storagedir/$computer/$sfilesystem/$backuplevel does not exist"
+       cd $storagedir/$computer/$sfilesystem/$backuplevel || diemsg "$storagedir/$computer/$sfilesystem/$backuplevel does not exist"
 
        # Perform the actual backup
-       backup
-
-       # Check if this box has a custom number of full backups
-       if [ -f $confdir/maksfulle.$computer.$sfilesystem ]; then
-               mf=$((`cat $confdir/maksfulle.$computer`+1))
-       elif [ -f $confdir/maksfulle.$computer ] ; then
-               mf=$((`cat $confdir/maksfulle.$computer`+1))
+       if [ "$( findconf nonpriv $computer )" ]; then
+               nonprivbackup
        else
-               mf=$(($maxnumfull+1))
+               backup
        fi
 
        # Delete old full backups
-       for full in `ls -1t $storagedir/$computer/$sfilesystem/full/*tgz | tail -n +$mf`; do
+       mf=$( findconf maxnumfull $computer $filesystem )
+       mf=$(( mf + 1 ))
+       for full in `ls -1t $storagedir/$computer/$sfilesystem/full/*tgz* | tail -n +$mf`; do
                prefix=`echo $full | sed "s/\.[^.]*$//"`
-               echo `date`": $computer:$filesystem Deleting full backup $prefix" >&2
+               infomsg "$computer:$filesystem Deleting full backup $prefix"
                rm $prefix*
        done
 
        # Delete incremental backups older than the oldest full backup
-       oldf=`ls -t1 $storagedir/$computer/$sfilesystem/full/*tgz | tail -1`
+       oldf=`ls -t1 $storagedir/$computer/$sfilesystem/full/*tgz* | tail -1`
        find \
-               $storagedir/$computer/$sfilesystem/daglig \
+               $storagedir/$computer/$sfilesystem/daily \
                -type f \
                \! -newer $oldf \
                -printf "`date`: $computer: Deleting old incremental backup: %p\n" \
@@ -272,9 +357,12 @@ for filesystem in $filesystems; do
 done
 
 # Try to run postexec if it exist
-if ! ssh root@$computer "[ ! -f /root/.backup/postexec ] || /bin/bash -x /root/.backup/postexec" >&2; then
-       diemsg "Could not run $computer:/root/.backup/postexec"
+if ! ssh -n $username@$computer "[ ! -f $remotehome/.backup/postexec ] || /bin/bash -x $remotehome/.backup/postexec" >&2; then
+       diemsg "Could not run $computer:$remotehome/.backup/postexec"
 fi
 
+# Use warn so that we will get an email even on success.
+warnmsg "Backup completed successfully."
+
 # Remove lockfile
 rm $LOCKFILE